<?php

/**
 * PHP versions 4 and 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license. If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   Troubleticket
 * @package    QuickTicket
 * @author     Philippe Vandenberghe <info@qt-cute.org>
 * @copyright  2008-2012 The PHP Group
 * @version    2.2 build:20090816
 * @since      File available since Release 1.0.0
 * @deprecated File deprecated in Release 3.0.0
 */

session_start();
require_once('bin/qti_init.php');
include(Translate('qti_adm.php'));
if ( $oVIP->role!='A' ) die(Error(13));

include(Translate('qtim_map.php'));
include(Translate('qtim_map_adm.php'));
include('qtim_map_lib.php');

// INITIALISE

$oVIP->selfurl = 'qtim_map_adm.php';
$oVIP->selfname = 'Map';
$oVIP->exiturl = $oVIP->selfurl;
$oVIP->exitname = $oVIP->selfname;
$strPageversion = $L['map_adm']['Version'].' 2.2';
$arrSettings = array('m_map_gkey','m_map_gcenter','m_map_gzoom','m_map_gbuttons','m_map_gfind');

// read values
foreach($arrSettings as $strKey)
{
  if ( !isset($_SESSION[QT][$strKey]) )
  {
  $arr = GetParam(true,'param="'.$strKey.'"');
  if ( empty($arr) ) die('<span class="error">Parameters not found. The module is probably not installed properly.</span><br/><br/><a href="qti_adm_index.php">&laquo;&nbsp;'.$L['Exit'].'</a>');
  }
}

$arrSections = GetSectionTitles('A',-1,-1,'',QTI_SHOW_DOMAIN);

// Read png in directory

$intHandle = opendir('qtim_map');
$arrFiles = array();
while ( false!==($strFile = readdir($intHandle)) )
{
  if ( $strFile!='.' && $strFile!='..' ) {
  if ( substr($strFile,-4,4)=='.png' ) {
  if ( !strstr($strFile,'shadow') ) {
    $arrFiles[substr($strFile,0,-4)]=ucfirst(substr(str_replace('_',' ',$strFile),0,-4));
  }}}
}
closedir($intHandle);
asort($arrFiles);

// --------
// SUBMITTED for activation
// --------

if ( isset($_POST['ok']) && empty($_SESSION[QT]['m_map_gkey']) )
{
  $_SESSION[QT]['m_map_gkey'] = trim($_POST['m_map_gkey']); if ( strlen($_SESSION[QT]['m_map_gkey'])<8 ) $_SESSION[QT]['m_map_gkey']='';
  $oDB->Query('UPDATE '.TABSETTING.' SET setting="'.$_SESSION[QT]['m_map_gkey'].'" WHERE param="m_map_gkey"');
  $oVIP->EndMessage(NULL,$L['S_update'],'admin',2);
}

// --------
// SUBMITTED for changes
// --------

if ( isset($_POST['ok']) && !empty($_SESSION[QT]['m_map_gkey']) )
{
  $_SESSION[QT]['m_map_gkey'] = trim($_POST['m_map_gkey']); if ( strlen($_SESSION[QT]['m_map_gkey'])<8 ) $_SESSION[QT]['m_map_gkey']='';
  $_SESSION[QT]['m_map_gcenter'] = trim($_POST['m_map_gcenter']);
  $_SESSION[QT]['m_map_gzoom'] = trim($_POST['m_map_gzoom']);
  $_SESSION[QT]['m_map_gbuttons'] = substr($_POST['maptype'],0,1).(isset($_POST['nav']) ? '1' : '0').(isset($_POST['map']) ? '1' : '0').(isset($_POST['scale']) ? '1' : '0').(isset($_POST['overview']) ? '1' : '0').(isset($_POST['mousewheel']) ? '1' : '0');
  $_SESSION[QT]['m_map_gfind'] = trim($_POST['m_map_gfind']);
  // save value
  if ( empty($error) )
  {
    foreach($arrSettings as $strKey) $oDB->Query('UPDATE '.TABSETTING.' SET setting="'.$_SESSION[QT][$strKey].'" WHERE param="'.$strKey.'"');
  }

  // save setting files
  $strFilename = 'qtim_map/config.php';
  $strIcon = 'false'; if ( isset($_POST['mark_U']) ) { if ( !empty($_POST['mark_U']) ) $strIcon = '"'.$_POST['mark_U'].'"'; }
  $content = '<?php
  $_SESSION[QT]["m_map"]["U"] = array();
  $_SESSION[QT]["m_map"]["U"][0] = '.(isset($_POST['sec_U']) ? 'true' : 'false').';';
  if ( isset($_POST['sec_U']) )
  {
  if ( $_POST['mark_U']=='-' ) $_POST['mark_U']='0'; //required for I.E.
  $content .= '
  $_SESSION[QT]["m_map"]["U"]["list"] = '.(isset($_POST['list_U']) ? '"'.$_POST['list_U'].'"' : 'false').';
  $_SESSION[QT]["m_map"]["U"]["icon"] = '.$strIcon.';
  $_SESSION[QT]["m_map"]["U"]["shadow"] = '.(file_exists('qtim_map/'.$_POST['mark_U'].'_shadow.png') ? 'true' : 'false').';
  $_SESSION[QT]["m_map"]["U"]["printicon"] = '.(file_exists('qtim_map/'.$_POST['mark_U'].'.gif') ? 'true' : 'false').';
  $_SESSION[QT]["m_map"]["U"]["printshadow"] = '.(file_exists('qtim_map/'.$_POST['mark_U'].'_shadow.gif') ? 'true' : 'false').';
  ';
  }

  $b = false;
  foreach($arrSections as $intSecid=>$strSectitle)
  {
  $strIcon = 'false'; if ( isset($_POST['mark_'.$intSecid]) ) { if ( !empty($_POST['mark_'.$intSecid]) ) $strIcon = '"'.$_POST['mark_'.$intSecid].'"'; }
  $content .= '
  $_SESSION[QT]["m_map"]['.$intSecid.'] = array();
  $_SESSION[QT]["m_map"]['.$intSecid.'][0] = '.(isset($_POST['sec_'.$intSecid]) ? 'true' : 'false').';';
  if ( isset($_POST['sec_'.$intSecid]) )
  {
  if ( $_POST['mark_'.$intSecid]=='-' ) $_POST['mark_'.$intSecid]='0'; //required for I.E.
  $content .= '
  $_SESSION[QT]["m_map"]['.$intSecid.']["list"] = '.(isset($_POST['list_'.$intSecid]) ? '"'.$_POST['list_'.$intSecid].'"' : 'false').';
  $_SESSION[QT]["m_map"]['.$intSecid.']["icon"] = '.$strIcon.';
  $_SESSION[QT]["m_map"]['.$intSecid.']["shadow"] = '.(file_exists('qtim_map/'.$_POST['mark_'.$intSecid].'_shadow.png') ? 'true' : 'false').';
  $_SESSION[QT]["m_map"]['.$intSecid.']["printicon"] = '.(file_exists('qtim_map/'.$_POST['mark_'.$intSecid].'.gif') ? 'true' : 'false').';
  $_SESSION[QT]["m_map"]['.$intSecid.']["printshadow"] = '.(file_exists('qtim_map/'.$_POST['mark_'.$intSecid].'_shadow.gif') ? 'true' : 'false').';
  ';
  }
  if ( isset($_POST['sec_'.$intSecid]) ) $b=true;
  }

  if ( $b )
  {
  $strIcon = 'false'; if ( isset($_POST['mark_S']) ) { if ( !empty($_POST['mark_S']) ) $strIcon = '"'.$_POST['mark_S'].'"'; }
  $content .= '$_SESSION[QT]["m_map"]["S"] = array();
  $_SESSION[QT]["m_map"]["S"][0] = '.(isset($_POST['sec_S']) ? 'true' : 'false').';';
  if ( isset($_POST['sec_S']) )
  {
  if ( $_POST['mark_S']=='-' ) $_POST['mark_S']='0'; //required for I.E.
  $content .= '
  $_SESSION[QT]["m_map"]["S"]["list"] = '.(isset($_POST['list_S']) ? '"'.$_POST['list_S'].'"' : 'false').';
  $_SESSION[QT]["m_map"]["S"]["icon"] = '.$strIcon.';
  $_SESSION[QT]["m_map"]["S"]["shadow"] = '.(file_exists('qtim_map/'.$_POST['mark_S'].'_shadow.png') ? 'true' : 'false').';
  $_SESSION[QT]["m_map"]["S"]["printicon"] = '.(file_exists('qtim_map/'.$_POST['mark_S'].'.gif') ? 'true' : 'false').';
  $_SESSION[QT]["m_map"]["S"]["printshadow"] = '.(file_exists('qtim_map/'.$_POST['mark_S'].'_shadow.gif') ? 'true' : 'false').';
  ';
  }
  }
  $content .= '?>';
  if (!is_writable($strFilename)) $error="Impossible to write into the file [$strFilename].";
  if ( empty($error) )
  {
  if (!$handle = fopen($strFilename, 'w')) $error="Impossible to open the file [$strFilename].";
  }
  if ( empty($error) )
  {
  if ( fwrite($handle, $content)===FALSE ) $error="Impossible to write into the file [$strFilename].";
  fclose($handle);
  }

  if ( !$b && isset($_POST['sec_S']) ) $warning=$L['map_adm']['E_nosearch'];

  // exit
  if ( empty($error) ) $strInfo = $L['S_save'];
}

// --------
// HTML START
// --------

// prepare section settings

$_SESSION[QT]['m_map'] = array();
if ( file_exists('qtim_map/config.php') ) require_once('qtim_map/config.php');

  if ( !isset($_SESSION[QT]['m_map']['U']) ) $_SESSION[QT]['m_map']['U'] = array(0=>false);
  foreach($arrSections as $intSecid=>$strSectitle)
  {
  if ( !isset($_SESSION[QT]['m_map'][$intSecid]) ) $_SESSION[QT]['m_map'][$intSecid] = array(0=>false);
  }
  if ( !isset($_SESSION[QT]['m_map']['S']) ) $_SESSION[QT]['m_map']['S'] = array(0=>false);


// DISPLAY

if ( !empty($_SESSION[QT]['m_map_gkey']) )
{
  $strBodyAddOnunload='GUnload()';
}

include('qti_adm_p_header.php');
include('qti_adm_p_title.php');

echo '<form method="post" action="',$oVIP->selfurl,'">
<table class="data_o" cellspacing="0">
<colgroup span="3"><col width="150"></col><col width="250"></col><col></col></colgroup>
';
echo '<tr class="data_o">
<td class="th_o th_o_all" colspan="3">',$L['map_adm']['Mapping_settings'],'</td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_first"><label for="m_map_gkey">',$L['map_adm']['API_key'],'</label></td>
<td class="td_o" colspan="2">
<input type="text" id="m_map_gkey" name="m_map_gkey" class="small" size="90" maxlength="100" value="',$_SESSION[QT]['m_map_gkey'],'" style="background-color:#FFFF99"/>
</td>
</tr>
';
// ----------
if ( !empty($_SESSION[QT]['m_map_gkey']) ) {
// ----------
echo '<tr class="data_o">
<td class="th_o th_o_first">',$L['map_adm']['API_ctrl'],'</td>
<td class="td_o" colspan="2">
<input type="checkbox" id="nav" name="nav"'.(substr($_SESSION[QT]['m_map_gbuttons'],1,1)=='1' ? QCHE : '').' style="vertical-align: middle"/> <label for="nav">',$L['map_adm']['Ctrl_navigation'],'</label>
&nbsp;<input type="checkbox" id="map" name="map"'.(substr($_SESSION[QT]['m_map_gbuttons'],2,1)=='1' ? QCHE : '').' style="vertical-align: middle"/> <label for="map">',$L['map_adm']['Ctrl_background'],'</label>
&nbsp;<input type="checkbox" id="scale" name="scale"'.(substr($_SESSION[QT]['m_map_gbuttons'],3,1)=='1' ? QCHE : '').' style="vertical-align: middle"/> <label for="scale">',$L['map_adm']['Ctrl_scale'],'</label>
&nbsp;<input type="checkbox" id="overview" name="overview"'.(substr($_SESSION[QT]['m_map_gbuttons'],4,1)=='1' ? QCHE : '').' style="vertical-align: middle"/> <label for="overview">',$L['map_adm']['Ctrl_overview'],'</label>
&nbsp;<input type="checkbox" id="mousewheel" name="mousewheel"'.(substr($_SESSION[QT]['m_map_gbuttons'],5,1)=='1' ? QCHE : '').' style="vertical-align: middle"/> <label for="mousewheel">',$L['map_adm']['Ctrl_mousewheel'],'</label>
</td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_first">',$L['map_adm']['Allowed'],'</td>
<td class="td_o" colspan="2">
<table class="hidden" style="border:solid 1px #c3d9ff">
<colgroup span="4"><col width="30"></col><col></col><col></col><col></col></colgroup>
<tr class="hidden">
<td style="background-color:#c3d9ff">&nbsp;</td>
<td style="background-color:#c3d9ff">',$L['Sections'],'</td>
<td style="background-color:#c3d9ff">',$L['map_adm']['Symbol'],'</td>
<td style="background-color:#c3d9ff">',$L['map_adm']['Main_list'],'</td>
</tr>
';
foreach($arrSections as $intSecid=>$strSectitle)
{
echo '
<tr class="rowlight">
<td style="background-color:#c3d9ff">
<input type="checkbox" id="sec_',$intSecid,'" name="sec_',$intSecid,'"'.($_SESSION[QT]['m_map'][$intSecid][0] ? QCHE : '').' style="vertical-align: middle" onclick="mapsection(\'',$intSecid,'\')"/>
</td>
<td>
<label for="sec_',$intSecid,'">',$strSectitle,'</label>
</td>
<td>
<select class="small" id="mark_',$intSecid,'" name="mark_',$intSecid,'" size="1" style="',($_SESSION[QT]['m_map'][$intSecid][0] ? '' : 'visibility:hidden'),'">
<option value="0">',$L['map_adm']['Default'],'</option>
<option value="-" disabled="disabled">-----------</option>
',QTasTag($arrFiles,(isset($_SESSION[QT]['m_map'][$intSecid]['icon']) ? $_SESSION[QT]['m_map'][$intSecid]['icon'] : null)),'
</select>
</td>
<td>
<select class="small" id="list_',$intSecid,'" name="list_',$intSecid,'" size="1" style="',($_SESSION[QT]['m_map'][$intSecid][0] ? '' : 'visibility:hidden'),'">',QTasTag($L['map_adm']['List'],(isset($_SESSION[QT]['m_map'][$intSecid]['list']) ? $_SESSION[QT]['m_map'][$intSecid]['list'] : null)),'</select>
</td>
</tr>
';
}
echo '
<tr class="rowlight">
<td style="background-color:#c3d9ff">
<input type="checkbox" id="sec_S" name="sec_S"'.($_SESSION[QT]['m_map']['S'][0] ? QCHE : '').' style="vertical-align: middle" onclick="mapsection(\'S\')"/>
</td>
<td><label for="sec_S"><i>Search results</i></label></td>
<td>
<select class="small" id="mark_S" name="mark_S" size="1" style="',($_SESSION[QT]['m_map']['S'][0] ? '' : 'visibility:hidden'),'">
<option value="S">',$L['map_adm']['From_section'],'</option>
<option value="0">',$L['map_adm']['Default'],'</option>
<option value="-" disabled="disabled">-----------</option>
',QTasTag($arrFiles,$_SESSION[QT]['m_map']['S']['icon']),'
</select>
</td>
<td>
<select class="small" id="list_S" name="list_S" size="1" style="',($_SESSION[QT]['m_map']['S'][0] ? '' : 'visibility:hidden'),'">',QTasTag(array('1'=>$L['map_adm']['List']['1'],'M'=>$L['map_adm']['List']['M']),$_SESSION[QT]['m_map']['S']['list']),'</select>
</td>
</tr>
<tr class="rowlight">
<td style="background-color:#c3d9ff">
<input type="checkbox" id="sec_U" name="sec_U"'.($_SESSION[QT]['m_map']['U'][0] ? QCHE : '').' style="vertical-align: middle" onclick="mapsection(\'U\')"/>
</td>
<td><label for="sec_U"><i>Users</i></label></td>
<td>
<select class="small" id="mark_U" name="mark_U" size="1" style="',($_SESSION[QT]['m_map']['U'][0] ? '' : 'visibility:hidden'),'">
<option value="0">',$L['map_adm']['Default'],'</option>
<option value="-" disabled="disabled">-----------</option>
',QTasTag($arrFiles,$_SESSION[QT]['m_map']['U']['icon']),'
</select>
</td>
<td>
<select class="small" id="list_U" name="list_U" size="1" style="',($_SESSION[QT]['m_map']['U'][0] ? '' : 'visibility:hidden'),'">',QTasTag($L['map_adm']['List'],$_SESSION[QT]['m_map']['U']['list']),'</select>
</td>
</tr>
';
echo '</table>
</td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_all" colspan="3">',$L['map_adm']['Mapping_config'],'</td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_first"><label for="m_map_gcenter">',$L['map_adm']['Center'],'</label></td>
<td class="td_o"><input type="text" id="m_map_gcenter" name="m_map_gcenter" size="28" maxlength="100" value="',$_SESSION[QT]['m_map_gcenter'],'"/><span class="small"> ',$L['map_adm']['Latlng'],'</span></td>
<td class="td_o"><span class="help">',$L['map_adm']['H_Center'],'</span></td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_first"><label for="m_map_gzoom">',$L['map_adm']['Zoom'],'</label></td>
<td class="td_o">
<input type="text" id="m_map_gzoom" name="m_map_gzoom" size="2" maxlength="2" value="',$_SESSION[QT]['m_map_gzoom'],'"/></td>
<td class="td_o"><span class="help">',$L['map_adm']['H_Zoom'],'</span></td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_first">',$L['map_adm']['Background'],'</td>
<td class="td_o"><select id="maptype" name="maptype" size="1">',QTasTag(array('M'=>'Map','S'=>'Satellite','H'=>'Hybrid (satellite+labels)','P'=>'Physical (terrain)'),substr($_SESSION[QT]['m_map_gbuttons'],0,1)),'</select></td>
<td class="td_o"><span class="help">',$L['map_adm']['H_Background'],'</span></td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_first"><label for="m_map_gfind">',$L['map_adm']['Address_sample'],'</label></td>
<td class="td_o">
<input type="text" id="m_map_gfind" name="m_map_gfind" size="20" maxlength="100" value="',$_SESSION[QT]['m_map_gfind'],'"/></td>
<td class="td_o"><span class="help">',$L['map_adm']['H_Address_sample'],'</span></td>
</tr>
';
// ----------
}
// ----------
echo '<tr class="data_o">
<td class="th_o th_o_all" colspan="3" style="padding:6px; text-align:center"><input type="submit" name="ok" value="',$L['Save'],'"/></td>
</tr>
';
echo '</table>
</form>
';

// ----------
if ( !empty($_SESSION[QT]['m_map_gkey']) ) {
// ----------

echo '
<table class="hidden" cellspacing="0">
<tr class="hidden">
<td class="hidden">

<h2>',$L['map_adm']['Preview'],'</h2>
<table class="data_o" style="width:460px;" cellspacing="0">
<tr class="data_o">
<td class="td_o">';
if ( empty($_SESSION[QT]['m_map_gkey']) )
{
  echo '<p class="disabled">',$L['map_adm']['E_disabled'],'</p>';
}
else
{
  echo '<p class="small" style="margin:2px 0 4px 2px;text-align:right">',$L['map']['canmove'],' | <a class="small" href="javascript:void(0)" onclick="undoChanges(); return false;"/>',$L['map']['undo'],'</a></p>',N;
  echo '<div id="map_canvas" style="width:500px; height:350px;"></div><input type="hidden" id="m_map_gcenter" name="m_map_gcenter" value="',$_SESSION[QT]['m_map_gcenter'],'"/>',N;
  echo '<p class="small" style="margin:4px 0 2px 2px;text-align:right">',$L['map']['addrlatlng'],' <input type="text" size="24" id="find" name="find" class="small" value="',$_SESSION[QT]['m_map_gfind'],'" onkeyup="handle_keypress(event,\'findit\')" title="',$L['map']['H_addrlatlng'],'"/> <input type="submit" id="findit" class="small" onclick="showLocation(document.getElementById(\'find\').value); return false;" value="',$L['Search'],'"/></p>',N;
}
echo '</td>
</tr>
</table>

</td>
<td class="hidden">

<h2>',$L['map_adm']['Other_symbols'],'</h2>
<table class="data_o" cellspacing="0">
';
foreach($arrFiles as $strFile=>$strName)
{
  echo '<tr class="data_o"><td class="td_o"><img src="qtim_map/',$strFile,'.png"/></td><td class="td_o"><span class="small">',$strName,'</span></td></tr>';
}
echo '
</table>

</td>
</tr>
</table>
';

// ----------
}
// ----------

// HTML END

if ( !empty($_SESSION[QT]['m_map_gkey']) )
{
  // map loader
  $x = QTgetx($_SESSION[QT]['m_map_gcenter']); //if ( empty($x) ) $x=0.0;
  $y = QTgety($_SESSION[QT]['m_map_gcenter']); //if ( empty($y) ) $y=0.0;
  $oMapPoint = new cMapPoint($y,$x,$L['map_adm']['Default_center'],'',false);

  $strFooterAddScript = QTgmapscript().'
  <script type="text/javascript">
  <!--
  '.QTgmappoints(false,$y,$x,'drag',array($oMapPoint),true).'
  function mapsection(section)
  {
    if (document.getElementById("sec_"+section).checked)
    {
    document.getElementById("mark_"+section).style.visibility="visible";
    document.getElementById("list_"+section).style.visibility="visible";
    }
    else
    {
    document.getElementById("mark_"+section).style.visibility="hidden";
    document.getElementById("list_"+section).style.visibility="hidden";
    }
    return null;
  }
  mapload();
  -->
  </script>
  ';
}

include('qti_adm_p_footer.php');

?>
